# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_TLS_VERIFY: 1
  DOCKER_CERT_PATH: "$DOCKER_TLS_CERTDIR/client"

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  image: registry.gitlab.com/fj-vision-intelligence/docker/gradle:1534831047
  services:
    - docker:20.10.8-dind
  script:
    - docker login -u $REGISTRY_USER -p $REGISTRY_PASSWORD
    - TAG=${CI_PIPELINE_IID}
    - DEST_IMAGE_NAME=ngfuji/pultry:$TAG
    - docker build -t $DEST_IMAGE_NAME .
    - docker push $DEST_IMAGE_NAME

deploy-job:      # This job runs in the deploy stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  image: 
    name: registry.gitlab.com/fj-vision-intelligence/docker/gradle:1534831047
  before_script:
    - mkdir -p  ~/.ssh
    - eval $(ssh-agent -s)
    - echo "$VAR_SSH_KEY" | ssh-add -
    - ssh-keyscan -H gitlab.com >> ~/.ssh/known_hosts
    - git config --global user.email "gitlab@fujitsu.com"
    - git config --global user.name "Gitlab Runner"
    - git clone git@gitlab.com:norbert.gebicki/as-gitops-deployment.git
  script: |
    echo "Deploying application..."
    ls
    cd as-gitops-deployment/apps/poultry-app/
    ls
    sed -i "s/image: ngfuji\/pultry:.*/image: ngfuji\/pultry:${CI_PIPELINE_IID}/g" poultry.yaml
    git commit -am "fix($CI_PROJECT_NAME): updating app with new image tag"
    git push
    echo "Application successfully deployed."
